<template>
  <div class="py-4 bet-history-table-container">
    <el-scrollbar style="height: 510px;">
      <div class="rounded-lg sport-bet-table" :class="{'border-table-wrapper': sportsBetsForDispay.length}">
        <el-table
          :key="Math.random()"
          :data="sportsBetsForDispay"
          :span-method="objectSpanMethod"
          :row-class-name="tableRowClassName"
          border
          @cell-mouse-leave="cellMouseLeave"
          @cell-mouse-enter="cellMouseEnter"
        >
          <template #empty>
            <lazy-utils-not-found />
          </template>
          <el-table-column
            align="center"
            prop="GameProviderName"
            :label="$t('provider')"
            width="75"
          />
          <el-table-column header-align="center" :label="$t('details')" width="205">
            <template #default="scope">
              <div class="flex flex-col" :class="themeName === 'peru' ? 'leading-4' : ''">
                <div
                  v-if="scope.row.BetDetails"
                  :key="scope.row.BetDetails"
                  class="m-0 flex flex-col text-right py-1 table-border leading-4"
                >
                  <lazy-desktop-bet-details-sport-bet-selection
                    :sport-bet-detail="scope.row.BetDetails[0]"
                    :sport-bet="scope.row"
                  />
                </div>
              </div>
            </template>
          </el-table-column>
          <el-table-column
            header-align="center"
            align="left"
            :label="$t('reference_number')"
            width="320"
          >
            <template #default="scope">
              <div
                v-if="scope.row.IsShowBetDetailButton"
                class="underline cursor-pointer break-words"
                @click="onDisplayBetDetail(scope.row)"
              >
                <span :class="themeName === 'peru' ? '--text5' : 'fc-secondary'">{{
                  scope.row.RefNo
                }}</span>
              </div>
              <div v-else class="break-words">{{ scope.row.RefNo }}</div>
              <div v-if="scope.row.GameRoundId">{{ scope.row.GameRoundId }}</div>
              <div v-if="scope.row.GamePeriodId">{{ scope.row.GamePeriodId }}</div>
            </template>
          </el-table-column>
          <el-table-column align="center" :label="$t('odds')" width="70">
            <template #default="scope">
              <div class="flex flex-col text-center">
                <div>{{ scope.row.MainBetOddsForDisplay }}</div>
                <div>{{ scope.row.OddsStyle }}</div>
              </div>
            </template>
          </el-table-column>
          <el-table-column align="center" :label="$t('stake')" width="80">
            <template #default="scope">
              <div class="flex flex-col text-center">
                <div>{{ scope.row.StakeForDisplay }}</div>
                <div>{{ scope.row.ActualStakeForDisplay }}</div>
              </div>
            </template>
          </el-table-column>
          <el-table-column
            v-if="isSettled"
            header-align="center"
            align="right"
            :label="$t('win/lose')"
            width="80"
          >
            <template #default="scope">
              <div :class="`fc-${scope.row.WinLoseColorForDisplay}`">
                {{ scope.row.WinLoseForDisplay }}
              </div>
            </template>
          </el-table-column>
          <el-table-column
            v-if="isSettled"
            header-align="center"
            align="right"
            prop="PlayerCommissionForDisplay"
            :label="$t('commission')"
            width="100"
          />
          <el-table-column align="center" :label="$t('status')">
            <template #default="scope">
              <div class="flex flex-col text-right">
                <div class="text-center status-display flex-col">
                  <div v-if="scope.row.BetDetails">
                    <div
                      v-if="scope.row.FirstRowOfSameRefNo"
                      :class="`fc-${scope.row.StatusColorForDisplay}`"
                    >
                      {{ scope.row.StatusForDisplay }}
                      <div v-if="scope.row.IsCashOut">{{`(${$t('cash_out')})`}}</div>
                    </div>
                    <div
                      v-if="scope.row.IsMp"
                      :class="`fc-${scope.row.BetDetails[0].SubBetStatusColorForDisplay}`"
                    >
                      {{ scope.row.BetDetails[0].SubBetStatusForDisplay }}
                      <div v-if="scope.row.IsCashOut">{{`(${$t('cash_out')})`}}</div>
                    </div>
                    <template v-if="isSettled">
                      <div>HT {{ scope.row.BetDetails[0].HalfTimeScore }}</div>
                      <div>FT {{ scope.row.BetDetails[0].FullTimeScore }}</div>
                    </template>
                  </div>
                </div>
              </div>
            </template>
          </el-table-column>
        </el-table>
      </div>
    </el-scrollbar>
  </div>
</template>
<script lang="ts">
import { defineComponent, PropType, ref, watch } from "vue";
import { ISportBet, SportBet } from "@/models/sportbet/sportbet";
import { store } from "~~/store";

export default defineComponent({
  name: "SportBetCompo",
  props: {
    isThirdPartySport: {
      type: Boolean,
      default: false,
    },
    isSettled: {
      type: Boolean,
      default: false,
    },
    sportBet: {
      type: Object as PropType<Array<SportBet>>,
      required: true,
    },
    onDisplayBetDetail: {
      type: Function,
      required: true,
    },
  },
  setup(props) {
    class SportBetForDisplay extends SportBet {
      FirstRowOfSameRefNo?: boolean;
      BetDetailCount?: number;
      IsMp?: boolean;
    }

    const transformToDisplay = () => {
      const result: Array<SportBetForDisplay> = [];
      props.sportBet.forEach((bet: SportBetForDisplay) => {
        const betDetailCount = bet.BetDetails.length;
        if (betDetailCount === 1) {
          bet.FirstRowOfSameRefNo = true;
          bet.BetDetailCount = betDetailCount;
          bet.IsMp = false;
          result.push(bet);
          return;
        }

        bet.BetDetails.forEach((subBet, index) => {
          const inewBet: ISportBet = { ...bet };
          inewBet.BetDetails = [subBet];
          const newBet = new SportBetForDisplay(inewBet);
          newBet.FirstRowOfSameRefNo = index === 0;
          newBet.BetDetailCount = betDetailCount;
          newBet.IsMp = true;
          result.push(newBet);
        });
      });
      return result;
    };

    const sportsBetsForDispay = ref(transformToDisplay());

    watch(props, () => {
      sportsBetsForDispay.value = transformToDisplay();
    });

    interface IpMethodProps {
      row: SportBetForDisplay;
      columnIndex: number;
    }

    const objectSpanMethod = ({ row, columnIndex }: ISpanMethodProps) => {
      const selectionIndex = 1;
      const statusIndex = props.isSettled ? 7 : 5;

      const noShow = {
        rowspan: 0,
        colspan: 0,
      };
      const oneCell = {
        rowspan: 1,
        colspan: 1,
      };
      const mergerRowByBetDetailCount = {
        rowspan: row.BetDetailCount,
        colspan: 1,
      };

      if (row.MainBetSportsType === "Mix Parlay" && columnIndex === 1) {
        return {
          rowspan: 1,
          colspan: 1,
        };
      }

      if (columnIndex === selectionIndex || columnIndex === statusIndex) {
        return oneCell;
      }

      if (row.FirstRowOfSameRefNo) {
        return mergerRowByBetDetailCount;
      }

      return noShow;
    };

    const rowBeHover = ref("");

    interface IRowClassNameMethod {
      row: SportBetForDisplay;
    }

    const tableRowClassName = ({ row }: IRowClassNameMethod) => {
      const className = row.RefNo === rowBeHover.value ? "rowBeHover" : "";
      return className;
    };

    const cellMouseEnter = (row: SportBetForDisplay) => {
      rowBeHover.value = row.RefNo;
    };

    const cellMouseLeave = () => {
      rowBeHover.value = "";
    };
    const themeName = store.state.selectedThemeName;
    return {
      sportsBetsForDispay,
      objectSpanMethod,
      cellMouseEnter,
      cellMouseLeave,
      tableRowClassName,
      themeName,
    };
  },
});
</script>
<style>
:root {
  --el-table-row-hover-bg-color: var(--textBtn);
}
</style>
<style scoped lang="scss">
.bet-history-table-container {
  .bet-history-table {}
}
@media screen and (max-width: 639px) {
  .bet-history-table-container {
    display: none;
  }
  .bet-history-card-container {
    display: block;
  }
}

[theme-color="main_lightblue"] .status-display .fc-border {
  color: var(--text5);
}
.bet-history-card {
  border: 2px solid var(--border);
  background-color: var(--background5);
  border-radius: 8px;
  .card-header {
    color: var(--text);
    border-bottom: 2px solid var(--border);
    padding: 8px 16px;
    font-size: 12px;
    font-weight: 400;
  }
  .provider {
    font-size: 14px;
    color: var(--primary);
    font-weight: 700;
  }
  .status {
    font-size: 16px;
    line-height: 19px;
    font-weight: 700;
  }
  .card-body {
    padding: 8px 16px;
    font-size: 12px;
    color: var(--text);
    border-bottom: 2px solid var(--border);
    font-weight: 400;
    .handicap {
      color: var(--primary);
      font-size: 14px;
      font-weight: 700;
    }
  }
  .card-footer {
    padding: 8px 16px;
    font-size: 12px;
    font-weight: 400;
    color: var(--text);
  }
}
.status-display {
  height: 100px;
  display: flex;
  justify-content: center;
  align-items: center;
}

:deep(
    .el-table--enable-row-hover .el-table__body tr:hover > td.el-table__cell
  ) {
  /* reset default hover color */
  background-color: rgba(var(--primary), 0);
}
:deep(.rowBeHover) {
  /* add hover color by tableRowClassName */
  background-color: rgba(var(--primary), 0.05);
}
</style>
